@echo off
echo =====================================
echo           Recipes and Tests
echo              Windows CMD
echo -------------------------------------
echo.

SetLocal EnableDelayedExpansion 

set /a TC=0
set /a TF=0
set /a FC=0
set /a FF=0

FOR /F %%T in (Tests\Tests.txt) DO (
   echo =====================================
   echo %%T
   echo -------------------------------------
   echo Running test...
   set /a TC+=1
   type Tests\%%T.test | .\capcli >Tests\Logs\%%T.log 2>&1
   echo Checking output files...
   set /a FX=0
   setlocal DisableDelayedExpansion
   for /F "tokens=1* delims= " %%E in (Tests\%%T.expected) DO (
      REM EXpected CRC32:%%E Filename:%%F
      set /a FC+=1
      for /F %%C in ('crc32 "%%F"') do (
         REM Calculated CRC32: %%C
         if "%%E" == "%%C" (
            echo %%F...[92mOK[0m
            ) else (
            echo %%F...[91mFAILED[0m
            set /a FF+=1
            set /a FX=1
            )
         )
      )
   if !FX! == 1 (
      set /a TF+=1
      )
)
echo =====================================
echo Summary
echo -------------------------------------
if %FF% gtr 0 (
   echo %TF% tests of %TC% [91mFAILED[0m
   echo %FF% files of %FC% [91mFAILED[0m
   ) else (
   echo %TC% tests of %TC% [92mOK[0m
   echo %FC% files of %FC% [92mOK[0m
   )

EndLocal